Index: /bdm/stat/libBM.h
===================================================================
--- /bdm/stat/libBM.h (revision 267)
+++ /bdm/stat/libBM.h (revision 270)
@@ -224,359 +284,375 @@
 //TODO Samplecond can be generalized
 
-	class mpdf : public bdmroot {
-	protected:
-		//! modeled random variable
-		RV rv;
-		//! random variable in condition
-		RV rvc;
-		//! pointer to internal epdf
-		epdf* ep;
-	public:
-
-		//! Returns a sample from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv 
-		virtual vec samplecond ( const vec &cond) {
-			this->condition ( cond );
-			vec temp= ep->sample();
-			return temp;
-		};
-		//! Returns \param N samples from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv \param ll is a return value of log-likelihood of the sample.
-		virtual mat samplecond_m ( const vec &cond, vec &ll, int N ) {
-			this->condition ( cond );
-			mat temp ( rv.count(),N ); vec smp ( rv.count() );
-			for ( int i=0;i<N;i++ ) {smp=ep->sample() ;temp.set_col ( i, smp );ll ( i ) =ep->evallog ( smp );}
-			return temp;
-		};
-		//! Update \c ep so that it represents this mpdf conditioned on \c rvc = cond
-		virtual void condition ( const vec &cond ) {it_error ( "Not implemented" );};
-
-		//! Shortcut for conditioning and evaluation of the internal epdf. In some cases,  this operation can be implemented efficiently.
-		virtual double evallogcond ( const vec &dt, const vec &cond ) {
-			double tmp; this->condition ( cond );tmp = ep->evallog ( dt );		it_assert_debug ( std::isfinite ( tmp ),"Infinite value" ); return tmp;
-		};
-
-		//! Matrix version of evallogcond
-		virtual vec evallogcond_m ( const mat &Dt, const vec &cond ) {this->condition ( cond );return ep->evallog_m ( Dt );};
-
-		//! Destructor for future use;
-		virtual ~mpdf() {};
-
-		//! Default constructor
-		mpdf ( const RV &rv0, const RV &rvc0 ) :rv ( rv0 ),rvc ( rvc0 ) {};
-		//! access function
-		RV _rvc() const {return rvc;}
-		//! access function
-		RV _rv() const {return rv;}
-		//!access function
-		epdf& _epdf() {return *ep;}
-		//!access function
-		epdf* _e() {return ep;}
+class mpdf : public bdmroot {
+protected:
+	//!dimension of the condition
+	int dimc;
+	//! random variable in condition
+	RV rvc;
+	//! pointer to internal epdf
+	epdf* ep;
+public:
+	//! \name Constructors
+	//! @{
+	
+	mpdf ( ) :dimc(0),rvc ( ) {};
+	//! copy constructor does not set pointer \c ep - has to be done in offsprings!
+	mpdf (const mpdf &m ) :dimc(m.dimc),rvc (m.rvc ) {};
+	//!@}
+
+	//! \name Matematical operations
+	//!@{
+	
+	//! Returns a sample from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv
+	virtual vec samplecond ( const vec &cond ) {
+		this->condition ( cond );
+		vec temp= ep->sample();
+		return temp;
 	};
-
-	/*! \brief DataLink is a connection between two data vectors Up and Down
-
-	Up can be longer than Down. Down must be fully present in Up (TODO optional)
-	See chart:
-	\dot
-	digraph datalink {
-		node [shape=record];
-		subgraph cluster0 {
-			label = "Up";
-	    	up [label="<1>|<2>|<3>|<4>|<5>"];
-			color = "white"
-	}
-		subgraph cluster1{
-			label = "Down";
-			labelloc = b;
-	    	down [label="<1>|<2>|<3>"];
-			color = "white"
-	}
-	    up:1 -> down:1;
-	    up:3 -> down:2;
-	    up:5 -> down:3;
-	}
-	\enddot
-
-	*/
-	class datalink_e2e {
-	protected:
-		//! Remember how long val should be
-		int valsize;
-		//! Remember how long val of "Up" should be
-		int valupsize;
-		//! val-to-val link, indeces of the upper val
-		ivec v2v_up;
-	public:
-		//! Constructor
-		datalink_e2e ( const RV &rv, const RV &rv_up ) :
-				valsize ( rv.count() ), valupsize ( rv_up.count() ), v2v_up ( rv.dataind ( rv_up ) )  {
-			it_assert_debug ( v2v_up.length() ==valsize,"rv is not fully in rv_up" );
-		}
-		//! Get val for myself from val of "Up"
-		vec get_val ( const vec &val_up ) {it_assert_debug ( valupsize==val_up.length(),"Wrong val_up" ); return get_vec ( val_up,v2v_up );}
-		//! Fill val of "Up" by my pieces
-		void fill_val ( vec &val_up, const vec &val ) {
-			it_assert_debug ( valsize==val.length(),"Wrong val" );
-			it_assert_debug ( valupsize==val_up.length(),"Wrong val_up" );
-			set_subvector ( val_up, v2v_up, val );
-		}
+	//! Returns \param N samples from the density conditioned on \c cond, \f$x \sim epdf(rv|cond)\f$. \param cond is numeric value of \c rv \param ll is a return value of log-likelihood of the sample.
+	virtual mat samplecond_m ( const vec &cond, int N ) {
+		this->condition ( cond );
+		mat temp ( ep->dimension(),N ); vec smp ( ep->dimension() );
+		for ( int i=0;i<N;i++ ) {smp=ep->sample() ;temp.set_col ( i, smp );}
+		return temp;
 	};
+	//! Update \c ep so that it represents this mpdf conditioned on \c rvc = cond
+	virtual void condition ( const vec &cond ) {it_error ( "Not implemented" );};
+
+	//! Shortcut for conditioning and evaluation of the internal epdf. In some cases,  this operation can be implemented efficiently.
+	virtual double evallogcond ( const vec &dt, const vec &cond ) {
+		double tmp; this->condition ( cond );tmp = ep->evallog ( dt );		it_assert_debug ( std::isfinite ( tmp ),"Infinite value" ); return tmp;
+	};
+
+	//! Matrix version of evallogcond
+	virtual vec evallogcond_m ( const mat &Dt, const vec &cond ) {this->condition ( cond );return ep->evallog_m ( Dt );};
+
+	//! \name Access to attributes
+	//! @{
+	
+	RV _rv() {return ep->_rv();}
+	RV _rvc() {it_assert_debug ( isnamed(),"" ); return rvc;}
+	int dimension() {return ep->dimension();}
+	int dimensionc() {return dimc;}
+	epdf& _epdf() {return *ep;}
+	epdf* _e() {return ep;}
+	//!@}
+	
+	//! \name Connection to other objects
+	//!@{
+	void set_rvc ( const RV &rvc0 ) {rvc=rvc0;}
+	void set_rv ( const RV &rv0 ) {ep->set_rv(rv0);}
+	bool isnamed() {return (ep->isnamed())&&(dimc==rvc._dsize());}
+	//!@}
+};
+
+/*! \brief DataLink is a connection between two data vectors Up and Down
+
+Up can be longer than Down. Down must be fully present in Up (TODO optional)
+See chart:
+\dot
+digraph datalink {
+	node [shape=record];
+	subgraph cluster0 {
+		label = "Up";
+    	up [label="<1>|<2>|<3>|<4>|<5>"];
+		color = "white"
+}
+	subgraph cluster1{
+		label = "Down";
+		labelloc = b;
+    	down [label="<1>|<2>|<3>"];
+		color = "white"
+}
+    up:1 -> down:1;
+    up:3 -> down:2;
+    up:5 -> down:3;
+}
+\enddot
+
+*/
+class datalink {
+protected:
+	//! Remember how long val should be
+	int downsize;
+	//! Remember how long val of "Up" should be
+	int upsize;
+	//! val-to-val link, indeces of the upper val
+	ivec v2v_up;
+public:
+	//! Constructor
+	datalink ( const RV &rv, const RV &rv_up ) :
+			downsize ( rv._dsize() ), upsize ( rv_up._dsize() ), v2v_up ( rv.dataind ( rv_up ) )  {
+		it_assert_debug ( v2v_up.length() ==downsize,"rv is not fully in rv_up" );
+	}
+	//! Get val for myself from val of "Up"
+	vec pushdown ( const vec &val_up ) {
+		it_assert_debug ( upsize==val_up.length(),"Wrong val_up" );
+		return get_vec ( val_up,v2v_up );
+	}
+	//! Fill val of "Up" by my pieces
+	void pushup ( vec &val_up, const vec &val ) {
+		it_assert_debug ( downsize==val.length(),"Wrong val" );
+		it_assert_debug ( upsize==val_up.length(),"Wrong val_up" );
+		set_subvector ( val_up, v2v_up, val );
+	}
+};
 
 //! data link between
-	class datalink_m2e: public datalink_e2e {
-	protected:
-		//! Remember how long cond should be
-		int condsize;
-		//!upper_val-to-local_cond link, indeces of the upper val
-		ivec v2c_up;
-		//!upper_val-to-local_cond link, ideces of the local cond
-		ivec v2c_lo;
-
-	public:
-		//! Constructor
-		datalink_m2e ( const RV &rv,  const RV &rvc, const RV &rv_up ) :
-				datalink_e2e ( rv,rv_up ), condsize ( rvc.count() ) {
-			//establish v2c connection
-			rvc.dataind ( rv_up, v2c_lo, v2c_up );
-		}
-		//!Construct condition
-		vec get_cond ( const vec &val_up ) {
-			vec tmp ( condsize );
-			set_subvector ( tmp,v2c_lo,val_up ( v2c_up ) );
-			return tmp;
-		}
-		void fill_val_cond ( vec &val_up, const vec &val, const vec &cond ) {
-			it_assert_debug ( valsize==val.length(),"Wrong val" );
-			it_assert_debug ( valupsize==val_up.length(),"Wrong val_up" );
-			set_subvector ( val_up, v2v_up, val );
-			set_subvector ( val_up, v2c_up, cond );
-		}
-	};
+class datalink_m2e: public datalink {
+protected:
+	//! Remember how long cond should be
+	int condsize;
+	//!upper_val-to-local_cond link, indeces of the upper val
+	ivec v2c_up;
+	//!upper_val-to-local_cond link, ideces of the local cond
+	ivec v2c_lo;
+
+public:
+	//! Constructor
+	datalink_m2e ( const RV &rv,  const RV &rvc, const RV &rv_up ) :
+			datalink ( rv,rv_up ), condsize ( rvc._dsize() ) {
+		//establish v2c connection
+		rvc.dataind ( rv_up, v2c_lo, v2c_up );
+	}
+	//!Construct condition
+	vec get_cond ( const vec &val_up ) {
+		vec tmp ( condsize );
+		set_subvector ( tmp,v2c_lo,val_up ( v2c_up ) );
+		return tmp;
+	}
+	void pushup_cond ( vec &val_up, const vec &val, const vec &cond ) {
+		it_assert_debug ( downsize==val.length(),"Wrong val" );
+		it_assert_debug ( upsize==val_up.length(),"Wrong val_up" );
+		set_subvector ( val_up, v2v_up, val );
+		set_subvector ( val_up, v2c_up, cond );
+	}
+};
 //!DataLink is a connection between mpdf and its superordinate (Up)
 //! This class links
-	class datalink_m2m: public datalink_m2e {
-	protected:
-		//!cond-to-cond link, indeces of the upper cond
-		ivec c2c_up;
-		//!cond-to-cond link, indeces of the local cond
-		ivec c2c_lo;
-	public:
-		//! Constructor
-		datalink_m2m ( const RV &rv, const RV &rvc, const RV &rv_up, const RV &rvc_up ) :
-				datalink_m2e ( rv, rvc, rv_up ) {
-			//establish c2c connection
-			rvc.dataind ( rvc_up, c2c_lo, c2c_up );
-			it_assert_debug ( c2c_lo.length() +v2c_lo.length() ==condsize, "cond is not fully given" );
-		}
-		//! Get cond for myself from val and cond of "Up"
-		vec get_cond ( const vec &val_up, const vec &cond_up ) {
-			vec tmp ( condsize );
-			set_subvector ( tmp,v2c_lo,val_up ( v2c_up ) );
-			set_subvector ( tmp,c2c_lo,cond_up ( c2c_up ) );
-			return tmp;
-		}
-		//! Fill
-
-	};
-
-	/*!
-	@brief Class for storing results (and semi-results) of an experiment
-
-	This class abstracts logging of results from implementation. This class replaces direct logging of results (e.g. to files or to global variables) by calling methods of a logger. Specializations of this abstract class for specific storage method are designed.
-	 */
-	class logger : public bdmroot {
-		protected:
-		//! RVs of all logged variables.
-			Array<RV> entries;
-		//! Names of logged quantities, e.g. names of algorithm variants
-			Array<string> names;
-		public:
-		//!Default constructor
-			logger ( ) : entries ( 0 ),names ( 0 ) {}
-
-		//! returns an identifier which will be later needed for calling the log() function
-			virtual int add ( const RV &rv, string name="" ) {
-				int id=entries.length();
-				names=concat ( names, name ); // diff
-				entries.set_length ( id+1,true );
-				entries ( id ) = rv;
-				return id; // identifier of the last entry
-			}
-
-		//! log this vector
-			virtual void logit ( int id, const vec &v ) =0;
-
-		//! Shifts storage position for another time step.
-			virtual void step() =0;
-
-		//! Finalize storing information
-			virtual void finalize() {};
-
-		//! Initialize the storage
-			virtual void init() {};
-
-		//! for future use
-			virtual ~logger() {};
-	};
-
-	/*! \brief Unconditional mpdf, allows using epdf in the role of mpdf.
-
-	*/
-	class mepdf : public mpdf {
-	public:
-		//!Default constructor
-		mepdf ( const epdf* em ) :mpdf ( em->_rv(),RV() ) {ep=const_cast<epdf*> ( em );};
-		void condition ( const vec &cond ) {}
-	};
+class datalink_m2m: public datalink_m2e {
+protected:
+	//!cond-to-cond link, indeces of the upper cond
+	ivec c2c_up;
+	//!cond-to-cond link, indeces of the local cond
+	ivec c2c_lo;
+public:
+	//! Constructor
+	datalink_m2m ( const RV &rv, const RV &rvc, const RV &rv_up, const RV &rvc_up ) :
+			datalink_m2e ( rv, rvc, rv_up ) {
+		//establish c2c connection
+		rvc.dataind ( rvc_up, c2c_lo, c2c_up );
+		it_assert_debug ( c2c_lo.length() +v2c_lo.length() ==condsize, "cond is not fully given" );
+	}
+	//! Get cond for myself from val and cond of "Up"
+	vec get_cond ( const vec &val_up, const vec &cond_up ) {
+		vec tmp ( condsize );
+		set_subvector ( tmp,v2c_lo,val_up ( v2c_up ) );
+		set_subvector ( tmp,c2c_lo,cond_up ( c2c_up ) );
+		return tmp;
+	}
+	//! Fill
+
+};
+
+/*!
+@brief Class for storing results (and semi-results) of an experiment
+
+This class abstracts logging of results from implementation. This class replaces direct logging of results (e.g. to files or to global variables) by calling methods of a logger. Specializations of this abstract class for specific storage method are designed.
+ */
+class logger : public bdmroot {
+protected:
+	//! RVs of all logged variables.
+	Array<RV> entries;
+	//! Names of logged quantities, e.g. names of algorithm variants
+	Array<string> names;
+public:
+	//!Default constructor
+	logger ( ) : entries ( 0 ),names ( 0 ) {}
+
+	//! returns an identifier which will be later needed for calling the log() function
+	virtual int add ( const RV &rv, string name="" ) {
+		int id=entries.length();
+		names=concat ( names, name ); // diff
+		entries.set_length ( id+1,true );
+		entries ( id ) = rv;
+		return id; // identifier of the last entry
+	}
+
+	//! log this vector
+	virtual void logit ( int id, const vec &v ) =0;
+
+	//! Shifts storage position for another time step.
+	virtual void step() =0;
+
+	//! Finalize storing information
+	virtual void finalize() {};
+
+	//! Initialize the storage
+	virtual void init() {};
+
+};
+
+/*! \brief Unconditional mpdf, allows using epdf in the role of mpdf.
+
+*/
+class mepdf : public mpdf {
+public:
+	//!Default constructor
+	mepdf ( const epdf* em ) :mpdf ( ) {ep=const_cast<epdf*> ( em );};
+	void condition ( const vec &cond ) {}
+};
 
 //!\brief Abstract composition of pdfs, will be used for specific classes
 //!this abstract class is common to epdf and mpdf
-	class compositepdf {
-	protected:
-		//!Number of mpdfs in the composite
-		int n;
-		//! Elements of composition
-		Array<mpdf*> mpdfs;
-	public:
-		compositepdf ( Array<mpdf*> A0 ) : n ( A0.length() ), mpdfs ( A0 ) {};
-		//! find common rv, flag \param checkoverlap modifies whether overlaps are acceptable
-		RV getrv ( bool checkoverlap=false );
-		//! common rvc of all mpdfs is written to rvc
-		void setrvc ( const RV &rv, RV &rvc );
-	};
-
-	/*! \brief Abstract class for discrete-time sources of data.
-
-	The class abstracts operations of: (i) data aquisition, (ii) data-preprocessing, (iii) scaling of data, and (iv) data resampling from the task of estimation and control.
-	Moreover, for controlled systems, it is able to receive the desired control action and perform it in the next step. (Or as soon as possible).
-
+class compositepdf {
+protected:
+	//!Number of mpdfs in the composite
+	int n;
+	//! Elements of composition
+	Array<mpdf*> mpdfs;
+public:
+	compositepdf ( Array<mpdf*> A0 ) : n ( A0.length() ), mpdfs ( A0 ) {};
+	//! find common rv, flag \param checkoverlap modifies whether overlaps are acceptable
+	RV getrv ( bool checkoverlap=false );
+	//! common rvc of all mpdfs is written to rvc
+	void setrvc ( const RV &rv, RV &rvc );
+};
+
+/*! \brief Abstract class for discrete-time sources of data.
+
+The class abstracts operations of: (i) data aquisition, (ii) data-preprocessing, (iii) scaling of data, and (iv) data resampling from the task of estimation and control.
+Moreover, for controlled systems, it is able to receive the desired control action and perform it in the next step. (Or as soon as possible).
+
+*/
+
+class DS : public bdmroot {
+protected:
+	int dtsize;
+	int utsize;
+	//!Description of data returned by \c getdata().
+	RV Drv;
+	//!Description of data witten by by \c write().
+	RV Urv; //
+	//! Remember its own index in Logger L
+	int L_dt, L_ut;
+public:
+	//! default constructors
+	DS() :Drv (  ),Urv ( ) {};
+	//! Returns full vector of observed data=[output, input]
+	virtual void getdata ( vec &dt ) {it_error ( "abstract class" );};
+	//! Returns data records at indeces.
+	virtual void getdata ( vec &dt, const ivec &indeces ) {it_error ( "abstract class" );};
+	//! Accepts action variable and schedule it for application.
+	virtual void write ( vec &ut ) {it_error ( "abstract class" );};
+	//! Accepts action variables at specific indeces
+	virtual void write ( vec &ut, const ivec &indeces ) {it_error ( "abstract class" );};
+
+	//! Moves from \f$ t \f$ to \f$ t+1 \f$, i.e. perfroms the actions and reads response of the system.
+	virtual void step() =0;
+
+	//! Register DS for logging into logger L
+	virtual void log_add ( logger &L ) {
+		it_assert_debug ( dtsize==Drv._dsize(),"" );
+		it_assert_debug ( utsize==Urv._dsize(),"" );
+
+		L_dt=L.add ( Drv,"" );
+		L_ut=L.add ( Urv,"" );
+	}
+	//! Register DS for logging into logger L
+	virtual void logit ( logger &L ) {
+		vec tmp ( Drv._dsize() +Urv._dsize() );
+		getdata ( tmp );
+		// d is first in getdata
+		L.logit ( L_dt,tmp.left ( Drv._dsize() ) );
+		// u follows after d in getdata
+		L.logit ( L_ut,tmp.mid ( Drv._dsize(), Urv._dsize() ) );
+	}
+	//!access function
+	virtual RV _drv() const {return concat ( Drv,Urv );}
+	//!access function
+	const RV& _urv() const {return Urv;}
+};
+
+/*! \brief Bayesian Model of a system, i.e. all uncertainty is modeled by probabilities.
+
+*/
+
+class BM :public bdmroot {
+protected:
+	//! Random variable of the data (optional)
+	RV drv;
+	//!Logarithm of marginalized data likelihood.
+	double ll;
+	//!  If true, the filter will compute likelihood of the data record and store it in \c ll . Set to false if you want to save computational time.
+	bool evalll;
+public:
+	//! \name Constructors
+	//! @{
+	
+	BM () :ll (0),evalll ( false) {};
+	BM ( const BM &B ) :  drv(B.drv), ll ( B.ll ), evalll ( B.evalll ) {}
+	//! Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually!
+	//! Prototype: \code BM* _copy_(){return new BM(*this);} \endcode
+	virtual BM* _copy_ () {return NULL;};
+	//!@}
+
+	//! \name Mathematical operations
+	//!@{
+	
+	/*! \brief Incremental Bayes rule
+	@param dt vector of input data
 	*/
-
-	class DS : public bdmroot {
-	protected:
-		//!Observed variables, returned by \c getdata().
-		RV Drv;
-		//!Action variables, accepted by \c write().
-		RV Urv; //
-		//! Remember its own index in Logger L
-		int L_dt, L_ut;
-	public:
-		DS() :Drv ( RV0 ),Urv ( RV0 ) {};
-		DS ( const RV &Drv0, const RV &Urv0 ) :Drv ( Drv0 ),Urv ( Urv0 ) {};
-		//! Returns full vector of observed data=[output, input]
-		virtual void getdata ( vec &dt ) {it_error ( "abstract class" );};
-		//! Returns data records at indeces.
-		virtual void getdata ( vec &dt, const ivec &indeces ) {it_error ( "abstract class" );};
-		//! Accepts action variable and schedule it for application.
-		virtual void write ( vec &ut ) {it_error ( "abstract class" );};
-		//! Accepts action variables at specific indeces
-		virtual void write ( vec &ut, const ivec &indeces ) {it_error ( "abstract class" );};
-
-		//! Moves from \f$t\f$ to \f$t+1\f$, i.e. perfroms the actions and reads response of the system.
-		virtual void step() =0;
-
-		//! Register DS for logging into logger L
-		virtual void log_add ( logger &L ) {
-			L_dt=L.add ( Drv,"" );
-			L_ut=L.add ( Urv,"" );
-		}
-		//! Register DS for logging into logger L
-		virtual void logit ( logger &L ) {
-			vec tmp(Drv.count()+Urv.count());
-			getdata(tmp);
-			// d is first in getdata
-			L.logit ( L_dt,tmp.left ( Drv.count() ) );
-			// u follows after d in getdata
-			L.logit ( L_ut,tmp.mid ( Drv.count(), Urv.count() ) );
-		}
-		//!access function 
-		virtual RV _drv() const {return concat(Drv,Urv);}
-		//!access function 
-		const RV& _urv() const {return Urv;}
-	};
-
-	/*! \brief Bayesian Model of a system, i.e. all uncertainty is modeled by probabilities.
-
-	*/
-
-	class BM :public bdmroot {
-	protected:
-		//!Random variable of the posterior
-		RV rv;
-		//! Random variable of the data (optional)
-		RV drv;
-		//!Logarithm of marginalized data likelihood.
-		double ll;
-		//!  If true, the filter will compute likelihood of the data record and store it in \c ll . Set to false if you want to save computational time.
-		bool evalll;
-	public:
-
-		//!Default constructor
-		BM ( const RV &rv0, double ll0=0,bool evalll0=true ) :rv ( rv0 ), ll ( ll0 ),evalll ( evalll0 ) {//Fixme: test rv
-		};
-		//!Copy constructor
-		BM ( const BM &B ) : rv ( B.rv ), ll ( B.ll ), evalll ( B.evalll ) {}
-
-		/*! \brief Incremental Bayes rule
-		@param dt vector of input data
-		*/
-		virtual void bayes ( const vec &dt ) = 0;
-		//! Batch Bayes rule (columns of Dt are observations)
-		virtual void bayesB ( const mat &Dt );
-		//! Returns a reference to the epdf representing posterior density on parameters.
-		virtual const epdf& _epdf() const =0;
-
-		//! Returns a pointer to the epdf representing posterior density on parameters. Use with care!
-		virtual const epdf* _e() const =0;
-
-		//! Evaluates predictive log-likelihood of the given data record
-		//! I.e. marginal likelihood of the data with the posterior integrated out.
-		virtual double logpred ( const vec &dt ) const{it_error ( "Not implemented" );return 0.0;}
-		//! Matrix version of logpred
-		vec logpred_m ( const mat &dt ) const{vec tmp ( dt.cols() );for ( int i=0;i<dt.cols();i++ ) {tmp ( i ) =logpred ( dt.get_col ( i ) );}return tmp;}
-
-		//!Constructs a predictive density (marginal density on data)
-		virtual epdf* predictor ( const RV &rv ) const {it_error ( "Not implemented" );return NULL;};
-
-		//! Destructor for future use;
-		virtual ~BM() {};
-		//!access function
-		const RV& _rv() const {return rv;}
-		//!access function 
-		const RV& _drv() const {return drv;}
-		//!set drv
-		void set_drv(const RV &rv){drv=rv;}
-		//!access function
-		double _ll() const {return ll;}
-		//!access function
-		void set_evalll ( bool evl0 ) {evalll=evl0;}
-
-		//! Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually!
-		//! Prototype: BM* _copy_(){BM Tmp*=new Tmp(this*);  return Tmp; }
-		virtual BM* _copy_ ( bool changerv=false ) {it_error ( "function _copy_ not implemented for this BM" ); return NULL;};
-	};
-
-	/*!
-	\brief Conditional Bayesian Filter
-
-	Evaluates conditional filtering density \f$f(rv|rvc,data)\f$ for a given \c rvc which is specified in each step by calling function \c condition.
-
-	This is an interface class used to assure that certain BM has operation \c condition .
-
-	*/
-
-	class BMcond :public bdmroot {
-	protected:
-		//! Identificator of the conditioning variable
-		RV rvc;
-	public:
-		//! Substitute \c val for \c rvc.
-		virtual void condition ( const vec &val ) =0;
-		//! Default constructor
-		BMcond ( RV &rv0 ) :rvc ( rv0 ) {};
-		//! Destructor for future use
-		virtual ~BMcond() {};
-		//! access function
-		const RV& _rvc() const {return rvc;}
-	};
+	virtual void bayes ( const vec &dt ) = 0;
+	//! Batch Bayes rule (columns of Dt are observations)
+	virtual void bayesB ( const mat &Dt );
+	//! Evaluates predictive log-likelihood of the given data record
+	//! I.e. marginal likelihood of the data with the posterior integrated out.
+	virtual double logpred ( const vec &dt ) const{it_error ( "Not implemented" );return 0.0;}
+	//! Matrix version of logpred
+	vec logpred_m ( const mat &dt ) const{vec tmp ( dt.cols() );for ( int i=0;i<dt.cols();i++ ) {tmp ( i ) =logpred ( dt.get_col ( i ) );}return tmp;}
+
+	//!Constructs a predictive density \f$ f(d_{t+1} |d_{t}, \ldots d_{0}) \f$
+	virtual epdf* epredictor (  ) const {it_error ( "Not implemented" );return NULL;};
+	//!Constructs a conditional density 1-step ahead predictor \f$ f(d_{t+1} |d_{t+h-1}, \ldots d_{t})
+	virtual mpdf* predictor ( ) const {it_error ( "Not implemented" );return NULL;};
+	//!@}
+	
+	//! \name Access to attributes
+	//!@{
+	
+	const RV& _drv() const {return drv;}
+	void set_drv ( const RV &rv ) {drv=rv;}
+	double _ll() const {return ll;}
+	void set_evalll ( bool evl0 ) {evalll=evl0;}
+	virtual const epdf& _epdf() const =0;
+	virtual const epdf* _e() const =0;
+	//!@}
+
+};
+
+/*!
+\brief Conditional Bayesian Filter
+
+Evaluates conditional filtering density \f$f(rv|rvc,data)\f$ for a given \c rvc which is specified in each step by calling function \c condition.
+
+This is an interface class used to assure that certain BM has operation \c condition .
+
+*/
+
+class BMcond :public bdmroot {
+protected:
+	//! Identificator of the conditioning variable
+	RV rvc;
+public:
+	//! Substitute \c val for \c rvc.
+	virtual void condition ( const vec &val ) =0;
+	//! Default constructor
+	BMcond ( ) :rvc ( ) {};
+	//! Destructor for future use
+	virtual ~BMcond() {};
+	//! access function
+	const RV& _rvc() const {return rvc;}
+};
 
 }; //namespace
Index: /bdm/stat/libFN.cpp
===================================================================
--- /bdm/stat/libFN.cpp (revision 262)
+++ /bdm/stat/libFN.cpp (revision 270)
@@ -5,17 +5,4 @@
 using namespace bdm;
 
-bilinfn::bilinfn ( const RV &rvx0, const RV &rvu0, const mat &A0, const mat &B0 ) : diffbifn (A0.rows(), rvx0,rvu0 )
-{
-	//check input
-	it_assert_debug ( ( A0.cols() ==dimx ) & ( A0.rows() ==B0.rows() ), "linfn:: wrong A" );
-	it_assert_debug ( ( B0.cols() ==dimu ), "linfn:: wrong B" );
-
-	// set dimensions
-	dimy = A0.rows();
-
-	//set internals
-	A = A0;
-	B = B0;
-};
 
 inline vec bilinfn::eval ( const  vec &x0, const vec &u0 )
Index: /bdm/stat/libDS.cpp
===================================================================
--- /bdm/stat/libDS.cpp (revision 267)
+++ /bdm/stat/libDS.cpp (revision 270)
@@ -26,10 +26,9 @@
 }
 
-void MemDS::linkrvs ( RV &drv, RV &urv ) {
-	it_assert_debug ( drv.count() ==rowid.length(),"MemDS::linkrvs incompatible drv" );
-	it_assert_debug ( urv.count() ==0,"MemDS does not support urv." );
+void MemDS::set_rvs ( RV &drv, RV &urv ) {
+	it_assert_debug ( drv._dsize() ==rowid.length(),"MemDS::set_rvs incompatible drv" );
+	it_assert_debug ( urv._dsize() ==0,"MemDS does not support urv." );
 
 	Drv = drv;
-	Urv = urv;
 }
 
@@ -44,10 +43,10 @@
 void ArxDS::step() {
 	//shift history
-	H.shift_right ( 0, Drv.count() +Urv.count() );
+	H.shift_right ( 0, Drv._dsize() +Urv._dsize() );
 
-	H.set_subvector ( Drv.count(), U ); // write U after Drv
+	H.set_subvector ( Drv._dsize(), U ); // write U after Drv
 
 	//get regressor
-	rgr = rgrlnk.get_val ( H );
+	rgr = rgrlnk->pushdown ( H );
 	// Eval Y
 	H.set_subvector ( 0, model.samplecond ( rgr ) );
@@ -66,8 +65,2 @@
 	return T;
 }
-
-ArxDS::ArxDS ( RV &drv, RV &urv, RV &rrv ) :
-		DS ( drv,urv ), Rrv ( rrv ), Hrv ( concat(drv,fullrgr ( drv,urv,rrv )) ), //RVs
-		H ( Hrv.count() ) ,U ( urv.count() ),rgr ( rrv.count() ),  //tmp variables
-		rgrlnk ( rrv, Hrv ) ,model ( drv,rrv ) {
-}
Index: /tests/testSmp.cpp
===================================================================
--- /tests/testSmp.cpp (revision 262)
+++ /tests/testSmp.cpp (revision 270)
@@ -32,5 +32,5 @@
 	
 	cout << "====== ENorm ====== " <<endl;
-	enorm<ldmat> eN(x);
+	enorm<ldmat> eN;
 	eN.set_parameters(mu0,R);
 	mat Smp = eN.sample(N);
@@ -40,8 +40,7 @@
 	cout << "====== MlNorm ====== " <<endl;
 	mat I = eye(2);
-	vec lik(N);
-	mlnorm<ldmat> ML(x,x);
+	mlnorm<ldmat> ML;
 	ML.set_parameters(I,zeros(2),R);
-	Smp = ML.samplecond_m(mu0,lik,N);
+	Smp = ML.samplecond_m(mu0,N);
 	
 	disp(mu0,R.to_mat(),Smp);
@@ -50,5 +49,5 @@
 	vec a = "100000,10000";
 	vec b = a/10.0;
-	egamma eG(x);
+	egamma eG;
 	eG.set_parameters(a,b);
 	
@@ -61,13 +60,13 @@
 
 	cout << "====== MGamma ====== " <<endl;	
-	mgamma mG(x,x);
+	mgamma mG;
 	double k = 10.0;
-	mG.set_parameters(k);
+	mG.set_parameters(k,mu0);
 
-	Smp=mG.samplecond_m(mu0,lik,N);
+	Smp=mG.samplecond_m(mu0,N);
 	disp(mu0,pow(mu0,2.0)/k,Smp);
 	
 	cout << "======= EMix ======== " << endl;
-	emix eMix(x);
+	emix eMix;
 	Array<epdf*> Coms(2);
 	Coms(0) = &eG;
@@ -82,9 +81,9 @@
 	mepdf meMix(&eMix);
 	
-	Smp = meMix.samplecond_m(mu0,lik,N);
+	Smp = meMix.samplecond_m(mu0,N);
 	disp(eMix.mean(),zeros(2),Smp);
 
 	cout << "======= MMix ======== " << endl;
-	mmix mMix(x,x);
+	mmix mMix;
 	Array<mpdf*> mComs(2);
 	mComs(0) = &mG;
@@ -94,15 +93,15 @@
 	mMix.set_parameters(vec_2(0.5,0.5),mComs);
 	
-	Smp = mMix.samplecond_m(mu0,lik,N);
+	Smp = mMix.samplecond_m(mu0,N);
 	disp(mMix._epdf().mean(),zeros(2),Smp);
 
 	cout << "======= EProd ======== " << endl;
 	// we have to change eG.rv to y
-	egamma eGy(x);
-	eGy.set_parameters(a,b);
+	eN.set_rv(x);
+	eG.set_rv(y);
 	//create array 
 	Array<mpdf*> A(2);
 	mepdf meN(&eN);
-	mepdf meG(&eGy);
+	mepdf meG(&eG);
 	A(0) = &meN;
 	A(1) = &meG;
@@ -114,6 +113,6 @@
 	
 	vec v0=vec(0);
-	Smp = eP.samplecond(v0,lik,N);
-	disp(concat(eN.mean(),eGy.mean()), epV,Smp);
+	Smp = eP.samplecond(v0,N);
+	disp(concat(eN.mean(),eG.mean()), epV,Smp);
 	
 	//Exit program:
Index: /tests/testKF.cpp
===================================================================
--- /tests/testKF.cpp (revision 262)
+++ /tests/testKF.cpp (revision 270)
@@ -54,5 +54,5 @@
 
 	//Chol
-	KalmanCh KF(rx,ry,ru);
+	KalmanCh KF;
 	KF.set_parameters(A,B,C,D,chmat(R),chmat(Q));
 	KF.set_est(mu0,chmat(P0) ); //prediction!
@@ -63,5 +63,5 @@
 	//	
 	// FSQMAT
-	Kalman<ldmat> KFf(rx,ry,ru);
+	Kalman<ldmat> KFf;
 	KFf.set_parameters(A,B,C,D,ldmat(R),ldmat(Q));
 	KFf.set_est(mu0,ldmat(P0) );
@@ -77,7 +77,7 @@
 	
 	// EKF
-	bilinfn fxu(rx,ru,A,B);
-	bilinfn hxu(rx,ru,C,D);
-	EKFCh KFE(rx,ry,ru);
+	bilinfn fxu(A,B);
+	bilinfn hxu(C,D);
+	EKFCh KFE;
 	KFE.set_parameters(&fxu,&hxu,Q,R);
 	KFE.set_est(mu0,chmat(P0));
Index: /tests/emix_test.cpp
===================================================================
--- /tests/emix_test.cpp (revision 254)
+++ /tests/emix_test.cpp (revision 270)
@@ -32,5 +32,5 @@
 	RV xy=concat(x,y);
 	
-	enorm<ldmat> E1 ( xy );
+	enorm<ldmat> E1; E1.set_rv ( xy );
 		
 	it_file iti("xxx");
@@ -41,5 +41,5 @@
 	cout << mu << R <<endl;
 	E1.set_parameters( mu, R);//"1.00054 1.0455" , mat ( "0.740142 -0.259015; -0.259015 1.0302" ));
-	enorm<ldmat> E2 ( xy );
+	enorm<ldmat> E2;E2.set_rv ( xy );
 	E2.set_parameters( "-1.2 -0.1" , mat ( "1 0.4; 0.4 0.5" ));
 
@@ -47,5 +47,5 @@
 	A1(0) = &E1;
 	
-	emix M1(xy);
+	emix M1; M1.set_rv(xy);
 	M1.set_parameters(vec("1"), A1, false);
 	cout << "======== test if ARX and emix with one ARX are the same ==="<<endl;
@@ -68,5 +68,5 @@
 	A2(1) = &E2;
 	
-	emix M2(xy);
+	emix M2; M2.set_rv(xy);
 	M2.set_parameters(vec("1"), A2, false);
 	
Index: /tests/testKF_QR.cpp
===================================================================
--- /tests/testKF_QR.cpp (revision 262)
+++ /tests/testKF_QR.cpp (revision 270)
@@ -48,18 +48,18 @@
 	RV rQR("{Q,R }","3");
 	//
-	KFcondQR KF(rx,ry,ru,rQR);
+	KFcondQR KF;
 	// KF with R unknown
 	KF.set_parameters(A,B,C,D,ldmat(R),ldmat(Q));
 	KF.set_est(mu0,ldmat(P0) );
 	//
-	Kalman<ldmat> KFtr(rx,ry,ru);
+	Kalman<ldmat> KFtr;
 	// KF with R unknown
 	KFtr.set_parameters(A,B,C,D,ldmat(R),ldmat(Q));
 	KFtr.set_est(mu0,ldmat(P0) );
 		
-	mgamma evolQR(rQR,rQR);
-	evolQR.set_parameters(10.0); //sigma = 1/10 mu
+	mgamma evolQR;
+	evolQR.set_parameters(10.0,"1 1 1"); //sigma = 1/10 mu
 	
-	MPF<KFcondQR > KF_QR(rx,rQR,evolQR,evolQR,100,KF);
+	MPF<KFcondQR > KF_QR(&evolQR,&evolQR,100,KF);
 	evolQR.condition("1 1 1");
 	epdf& pfinit=evolQR._epdf();
